; AD-APROX
; Author: Safranek David
; Icq: 69941919
; Email: safrad@email.cz
; Web: http://safrad.fbi.cz

.286
.MODEL small
.STACK 800h

.DATA
	Digits = 4
	VideoMem = 0A000h
	NameStr DB 'AD-APROX', 0
	AuthorStr DB 'Author: Safranek David', 0
	EmailStr DB 'Email: safrad@email.cz', 0
	IcqStr DB 'Icq: 69941919', 0
	WebStr DB 'Web: safrad.fbi.cz', 0

	SetZero DB     'Set Zero...                   ', 0
	SetMax DB      'Set 5V...                     ', 0
	StrInfo DB     'a: auto, r: recalib, Esc: Exit', 0

	UStr DB 'U=', 0
	NotCalibStr DB 'Not Calibrated! ', 0
	BadCalibStr DB 'Bad Calibration!', 0
	mVStr DB       ' mV             ', 0
	CalibStr DB 'Calib', 0

	AutoStr DB 'A', 0
	NullStr DB ' ', 0
	DataStr DB 256 DUP (?)

	Count DB 0
	Min DB ?
	Max DB ?
	x1 DW ?
	y1 DW ?
	x2 DW ?
	y2 DW ?

	AutoMode DB ?
;	k DB 0 ; debug

	Mule DW 1000, 100, 10, 1
	Value DW ?
	ValueB DB ?
	NotCalib DB 0
	BadCalib DB 0

	Sins DB 0,3,6,9,12,16,19,22,25,28,31,34,37,40,43,46,49,51,54,57,60
	DB 63,65,68,71,73,76,78,81,83,85,88,90,92,94,96,98,100,102,104,106,107
	DB 109,111,112,113,115,116,117,118,120,121,122,122,123,124,125,125,126
	DB 126,126,127,127,127,127,127,127,127,126,126,126,125,125,124,123,122
	DB 122,121,120,118,117,116,115,113,112,111,109,107,106,104,102,100,98
	DB 96,94,92,90,88,85,83,81,78,76,73,71,68,65,63,60,57,54,51,49,46,43
	DB 40,37,34,31,28,25,22,19,16,12,9,6,3,0,-3,-6,-9,-12,-16,-19,-22,-25,-28
	DB -31,-34,-37,-40,-43,-46,-49,-51,-54,-57,-60,-63,-65,-68,-71,-73,-76
	DB -78,-81,-83,-85,-88,-90,-92,-94,-96,-98,-100,-102,-104,-106,-107
	DB -109,-111,-112,-113,-115,-116,-117,-118,-120,-121,-122,-122,-123
	DB -124,-125,-125,-126,-126,-126,-127,-127,-127,-127,-127,-127,-127
	DB -126,-126,-126,-125,-125,-124,-123,-122,-122,-121,-120,-118,-117
	DB -116,-115,-113,-112,-111,-109,-107,-106,-104,-102,-100,-98,-96,-94
	DB -92,-90,-88,-85,-83,-81,-78,-76,-73,-71,-68,-65,-63,-60,-57,-54,-51
	DB -49,-46,-43,-40,-37,-34,-31,-28,-25,-22,-19,-16,-12,-9,-6,-3

.CODE
@LStart:
	mov ax, @data
	mov ds, ax
	xor ax, ax
	xor bx, bx
	xor cx, cx
	xor dx, dx
	xor di, di
	xor si, si

	; Set Mode 320x200x8
	mov ax, 0013h
	int 10h

;	mov di, VideoMem
;	mov es, di
;	mov di, 0
;	@LFill:
;		mov ax, di
;		mov byte ptr es:[di], al
;		inc di
;		cmp di, 64000
;	jne @LFill

	mov ax, 0
	mov bx, 120
	mov cl, 15
;	call Pix

	mov ax, 2
	mov bx, 122
	mov si, 100
	mov di, 122
	mov cl, 15
;	call Lin


;	mov ax, 1234
;	mov di, offset DataString
;	call @SIntToStr


	mov clr, 15
	mov cux, 0
	mov cuy, 0

	mov di, offset NameStr
	call IntWrite
	inc cuy

	mov clr, 7
	mov cux, 0
	mov di, offset AuthorStr
	call IntWrite
	inc cuy

	mov cux, 0
	mov di, offset IcqStr
	call IntWrite
	inc cuy

	mov cux, 0
	mov di, offset EmailStr
	call IntWrite
	inc cuy

	mov cux, 0
	mov di, offset WebStr
	call IntWrite
	inc cuy

	call Calib

	@LAgain:
		call Calc ; Value = Get U = ax

		call Draw

		call Keyb
	cmp al, 1bh
	jne @LAgain

	mov ax, 0
	int 16h
;	mov ax, 0000h
;	int 10h
	mov ax, 4c00h
	int 21h

@SSetU: ; al: Data
	push dx
	mov dx, 378h
	out dx, al
	pop dx
ret

@SGetComp: ; al: 0/1
	push dx
	mov dx, 379h
	in al, dx
	and al, 20h
	shr al, 5
	pop dx
ret

IntToStr PROC ; Value: ax; out to ds:di

	xor cx, cx
	SIntLoop:
		cmp cl, Digits - 1
		jne @LNotLastDigit
		mov ch, 1
		@LNotLastDigit:

		xor dx, dx
		mov dl, cl
		mov si, dx
		xor dx, dx
		shl si, 1
		mov bx, word ptr Mule[si]
		idiv bx ; ax = dx&ax / bx ; dx = dx&ax mod bx

		test al, al
		jnz @LNotZero
			; al = 0
			test ch, ch
			jnz @LNotZero
			mov al, ' '
			jmp @LNumEnd
		@LNotZero:
		; al <> 0
		mov ch, 1
		add al, '0'
		@LNumEnd:
		mov [di], al
		mov ax, dx
		inc di
		inc cl
		cmp cl, Digits
	jne SIntLoop
	mov byte ptr [di], 0
;	mov [di+1], byte ptr 'm'
;	mov [di+2], byte ptr 'V'
;	mov [di+3], byte ptr ' '
;	mov [di+4], byte ptr 0

ret
IntToStr ENDP

Calib PROC

	mov clr, 7
	mov cuy, 24
	mov cux, 0
	mov di, offset SetZero
	call IntWrite
	inc cuy

	xor ax, ax
	int 16h
	call @SAprox
;	mov cl, 16 ; debug
	mov Min, cl

	mov cuy, 24
	mov cux, 0
	mov di, offset SetMax
	call IntWrite
	inc cuy

	xor ax, ax
	int 16h
	call @SAprox
;	mov cl, 200 ; debug
	mov Max, cl

	mov di, offset DataStr
	xor ax, ax
	mov al, Min
	call IntToStr

	mov clr, 7
	mov cux, 0
	mov cuy, 6
	mov di, offset CalibStr
	call IntWrite
	inc cux

	mov di, offset DataStr
	call IntWrite

	mov di, offset DataStr
	xor ax, ax
	mov al, Max
	call IntToStr

	mov di, offset DataStr
	call IntWrite

	mov cuy, 24
	mov cux, 0
	mov di, offset StrInfo
	call IntWrite

	mov cl, Max
	cmp cl, Min
	ja @LOk
		mov NotCalib, 1

		mov clr, 15
		mov cuy, 8
		mov cux, 0
		mov di, offset NotCalibStr
		call IntWrite
		ret
	@LOk:
	mov NotCalib, 0

	ret
Calib ENDP

Calc PROC ; Fill Value
		cmp NotCalib, 0
		je @LCal
			ret
		@LCal:
		call @SAprox
;		mov cl, k ; debug
;		inc k ; debug

		mov ValueB, cl

		cmp cl, Min
		jae @LOk0
			mov BadCalib, 1
			ret
			jmp @LOk1
		@LOk0:
		cmp cl, Max
		jbe @LOk1
			mov BadCalib, 1
			ret
		@LOk1:
		mov BadCalib, 0
		sub cl, Min

		mov al, cl
		xor ah, ah
		mov bx, 10000 ; 5000 * 2
		imul bx ; dx&ax = ax * bx

		xor bh, bh
		mov bl, Max
		sub bl, Min
		shl bx, 1
		add ax, bx		
		adc dx, 0

		idiv bx ; ax = dx&ax / bx ; dx = dx&ax mod bx

		mov Value, ax

		ret
Calc ENDP

Draw PROC

		inc Count
		mov cux, 38
		mov cuy, 0
		mov cl, Count
		mov clr, cl
		mov di, offset AutoStr
		call IntWrite;

		cmp NotCalib, 0
		je @LDrawOk0
			ret
		@LDrawOk0:
		cmp BadCalib, 0
		je @LDrawOk1
			mov clr, 15
			mov cuy, 8
			mov cux, 0
			mov di, offset BadCalibStr
			call IntWrite
			ret
		@LDrawOk1:
		mov clr, 7
		mov cux, 0
		mov cuy, 8
		mov di, offset UStr
		call IntWrite

		mov ax, Value
		mov di, offset DataStr
		call IntToStr

		mov clr, 15
		mov di, offset DataStr
		call IntWrite

		mov clr, 7
		mov di, offset mVStr
		call IntWrite

		mov ax, Value
		shr ax, 4
		mov x2, ax
		mov x1, 0
		mov y1, 100
		mov y2, 100
		mov cl, 15
		test ax, ax
		je @LSkip0
			call Lin
		@LSkip0:

		mov ax, Value
		shr ax, 4
		inc ax
		mov x1, ax
		mov y1, 100
		mov x2, 313
		mov y2, 100
		mov cl, 8
		cmp ax, 313
		je @LSkip1
			call Lin
		@LSkip1:

		mov cl, 7
		mov ax, 160 ; X
		mov bx, 145 ; Y
		call Pix

		xor dx, dx
		@LNS:
			mov ch, 7
			mov cl, 2
			cmp dl, ValueB
			jne @LNV0
				mov ch, 15
				mov cl, 3
				jmp @LNV
			@LNV0:
			cmp dl, Min
			jne @LNV1
				mov ch, 12 ; red
				mov cl, 3
				jmp @LNV
			@LNV1:
			cmp dl, Max
			jne @LNV2
				mov ch, 9 ; blue
				mov cl, 3
				jmp @LNV
			@LNV2:


			@LNV:

			xor ax, ax
			xor bx, bx
			mov di, dx

			mov al, Sins[di]
			cbw
			sar ax, cl
			add ax, 145 ; Y
			mov bx, ax

			add di, 192
			and di, 0FFh
			mov al, Sins[di]
			cbw
			sar ax, cl
			add ax, 160 ; X

			mov cl, ch
			call Pix

			inc dl
			test dl, dl
		jne @LNS
	ret
Draw ENDP

@SAprox: ; out cl
	; Aprox
	mov dh, 0 ; MainValue
	mov cl, 0 ; RealValue
	mov dl, 80h ; Offset
	LLoop:
		mov dh, cl
		add dh, dl
		mov al, dh
		call @SSetU
		call @SGetComp
			cmp al, 1
			jne LFin
			mov cl, dh ; MainValue is smaller that RealValue
		LFin:

		shr dl, 1
	test dl, dl ; optim
	jne LLoop
ret

Keyb PROC
	cmp AutoMode, 0
	jne @LEl
		xor ax, ax
		int 16h
		jmp @LEn
	@LEl:
		call Kybrd
	@LEn:
	cmp al, 'a'
	jne @LEsc
		xor AutoMode, 1
		cmp AutoMode, 0
		je @LNul
		mov di, offset AutoStr
		jmp @LEn2
		@LNul:
		mov di, offset NullStr
		@LEn2:
		mov clr, 15
		mov cux, 39
		mov cuy, 0
		call IntWrite
	ret
	@LEsc:
	cmp al, 'r'
	jne @LNext2
		call Calib
	@LNext2:
	ret
Keyb ENDP

Pix PROC ; x-ax, y-bx, c-cl
	push es
	push di
	push bx
	mov di, VideoMem
	mov es, di
	mov di, bx
	shl di, 8
	shl bx, 6
	add di, bx
	add di, ax
	mov byte ptr es:[di], cl
	pop bx
	pop di
	pop es

	ret
Pix ENDP

Ab PROC
	test ax, ax
	jg @LMin
		neg ax
	@LMin:
	ret
Ab ENDP

LinSwap PROC
	mov ax, x2
	xchg x1, ax
	mov x2, ax

	mov ax, y2
	xchg y1, ax
	mov y2, ax

	ret
LinSwap ENDP

Lin PROC ; x1-ax, y1-bx, x2-si, y2-di, c-cl

	mov ax, x1
	mov bx, y1
	mov si, x2
	mov di, y2

	cmp ax, si
	jne @LN1
	@LX: ; X1=X2
		call Pix
		inc bx
		cmp bx, di
	jbe @LX

	jmp @LFin
	@LN1:
	cmp bx, di
	jne @LN2
	@LY: ; Y1=Y2
		call Pix
		inc ax
		cmp ax, si
	jbe @LY

	jmp @LFin
	@LN2:
		mov ax, x2
		sub ax, x1
		call Ab
		mov bx, ax
		mov ax, y2
		sub ax, y1
		call Ab
		cmp ax, bx
		jng @LN2x
			; (x2 - x1) > (y2 - y1)
			mov dx, ax
			xor ax, ax
			idiv bx ; ax = dx&ax / bx ; dx = dx&ax mod bx
			mov dx, ax

			mov ax, x2
			cmp ax, x1
			jge @LX0
				call LinSwap
			@LX0:
			mov ax, x1
			@LX1:
				mov bx, ax
				sub bx, x1
;				mov ax
;				mul bx

				call Pix
				inc ax
				cmp ax, x2
			jng @LX1

		jmp @LFin
		@LN2x:
			; (x2 - x1) < (y2 - y1)



	@LFin:
	ret
Lin ENDP

INCLUDE Common.inc

END @LStart
